diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index b0d51b7e2..33956bcfd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -7,19 +7,19 @@ import net.minecraft.core.item.block.ItemBlockLayerLeaves;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicLayerLeaves extends BlockLogicLayerBase
-{
+public class BlockLogicLayerLeaves extends BlockLogicLayerBase {
     public static final int MASK_PERMANENT = 0b1000_0000;
 
-	public BlockLogicLayerLeaves(Block<? extends BlockLogicLayerLeaves> block, Block<?> fullBlock, Material material) {
+    public BlockLogicLayerLeaves(Block<? extends BlockLogicLayerLeaves> block, Block<?> fullBlock, Material material) {
         super(block, fullBlock, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         block.setTicking(true);
@@ -27,41 +27,40 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerBase
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
-    public void accumulate(@NotNull World world, @NotNull TilePos tilePos)
-    {
-    	int myMetadata = world.getBlockData(tilePos);
-    	if (myMetadata == 0x7) return;
+    public void accumulate(@NotNull World world, @NotNull TilePosc tilePos) {
+        int myMetadata = world.getBlockData(tilePos);
+        if (myMetadata == 0x7) return;
 
         for (int i = 0; i < Direction.horizontalDirections.length; i++) {
-            TilePos p = tilePos.add(Direction.horizontalDirections[i]);
+            TilePos p = tilePos.add(Direction.horizontalDirections[i], new TilePos());
 
             if (!((world.isBlockOpaqueCube(p)) || (world.getBlockId(p) == this.block.id() && world.getBlockData(p) >= myMetadata))) {
                 return;
             }
         }
 
-    	world.setBlockData(tilePos, myMetadata + 1);
-    	world.markBlockNeedsUpdate(tilePos);
+        world.setBlockData(tilePos, myMetadata + 1);
+        world.markBlockNeedsUpdate(tilePos);
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
-        TilePos down = tilePos.down();
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos down = tilePos.down(new TilePos());
         Block<?> b = world.getBlock(down);
-        if(b == null || (!b.isSolidRender() && !(b.getLogic() instanceof BlockLogicLeavesBase))) {
-        	return false;
+        if (b == null || (!b.isSolidRender() && !(b.getLogic() instanceof BlockLogicLeavesBase))) {
+            return false;
         } else {
-        	Material material = world.getBlockMaterial(down);
+            Material material = world.getBlockMaterial(down);
             return material.blocksMotion();
         }
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         // Remove if no longer valid
         if (!canPlaceAt(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
@@ -72,16 +71,17 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerBase
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return switch (dropCause) {
-            case SILK_TOUCH -> new ItemStack[]{new ItemStack(this, (data & ~MASK_PERMANENT) + 1)}; // Drop amount equal to number of layers
+            case SILK_TOUCH ->
+                new ItemStack[]{new ItemStack(this, (data & ~MASK_PERMANENT) + 1)}; // Drop amount equal to number of layers
             case PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
             default -> null;
         };
     }
 
     @Override
-    public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
-    	if (world.getSeasonManager().getCurrentSeason() != null && !world.getSeasonManager().getCurrentSeason().hasFallingLeaves) {
-    		int metadata = world.getBlockData(tilePos);
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (world.getSeasonManager().getCurrentSeason() != null && !world.getSeasonManager().getCurrentSeason().hasFallingLeaves) {
+            int metadata = world.getBlockData(tilePos);
             if (!isPermanent(metadata)) {
                 if (rand.nextInt(2) == 0) {
                     if (metadata > 0) {
@@ -91,14 +91,15 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerBase
                     }
                 }
             }
-    	}
+        }
     }
 
-    public static boolean isPermanent(int meta){
+    public static boolean isPermanent(int meta) {
         return (meta & MASK_PERMANENT) != 0;
     }
+
     public static int setPermanent(int meta, boolean flag) {
-        if (flag){
+        if (flag) {
             return meta | MASK_PERMANENT;
         } else {
             return meta & ~MASK_PERMANENT;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index b67f3335b..68834459e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -1,65 +1,67 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Items;
-import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicLayerSnow extends BlockLogicLayerBase
-{
+public class BlockLogicLayerSnow extends BlockLogicLayerBase {
 
-	public BlockLogicLayerSnow(@NotNull Block<? extends BlockLogicLayerBase> block, @Nullable Block<?> fullBlock, @NotNull Material material) {
+    public BlockLogicLayerSnow(@NotNull Block<? extends BlockLogicLayerBase> block, @Nullable Block<?> fullBlock, @NotNull Material material) {
         super(block, fullBlock, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         block.setTicking(true);
     }
 
-    public void accumulate(@NotNull World world, @NotNull TilePos tilePos) {
-    	int myMetadata = world.getBlockData(tilePos);
-    	if (myMetadata == 0x7) return;
+    public void accumulate(@NotNull World world, @NotNull TilePosc tilePos) {
+        int myMetadata = world.getBlockData(tilePos);
+        if (myMetadata == 0x7) return;
 
         for (int i = 0; i < Direction.horizontalDirections.length; i++) {
             Direction dir = Direction.horizontalDirections[i];
-            TilePos dirPos = tilePos.add(dir);
-            if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockId(dirPos) == this.block.id() && world.getBlockData(dirPos) >= myMetadata))) return;
+            TilePos dirPos = tilePos.add(dir, new TilePos());
+            if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockId(dirPos) == this.block.id() && world.getBlockData(dirPos) >= myMetadata)))
+                return;
         }
 
-    	world.setBlockData(tilePos, myMetadata + 1);
-    	world.markBlockNeedsUpdate(tilePos);
+        world.setBlockData(tilePos, myMetadata + 1);
+        world.markBlockNeedsUpdate(tilePos);
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
-        TilePos down = tilePos.down();
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos down = tilePos.down(new TilePos());
         Block<?> b = world.getBlock(down);
-        if(b == null || (!b.isSolidRender() && !(b.getLogic() instanceof BlockLogicLeavesBase))) {
-        	return false;
+        if (b == null || (!b.isSolidRender() && !(b.getLogic() instanceof BlockLogicLeavesBase))) {
+            return false;
         } else {
-        	Material material = world.getBlockMaterial(down);
-            return material == Material.leaves || material.blocksMotion();
+            Material material = world.getBlockMaterial(down);
+            return material == Materials.LEAVES || material.blocksMotion();
         }
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-        final AABB aabb = getBounds();
-        aabb.maxY = Math.max(aabb.maxY - 2/16f, tilePos.y);
-        return aabb;
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        final AABBdc aabb = getBounds();
+        return new AABBd(aabb).setMax(aabb.maxX(), Math.max(aabb.maxY() - 2 / 16f, tilePos.y()), aabb.maxZ());
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         // Remove if no longer valid
         if (!canPlaceAt(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
@@ -78,12 +80,12 @@ public class BlockLogicLayerSnow extends BlockLogicLayerBase
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
-		if(world.getSavedLightValue(LightLayer.Block, tilePos) > 11) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (world.getSavedLightValue(LightLayer.Block, tilePos) > 11) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-			world.setBlockIdNotify(tilePos, 0);
-		}
-        if(!world.getBlockBiome(tilePos).hasSurfaceSnow() && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) {
+            world.setBlockIdNotify(tilePos, 0);
+        }
+        if (!world.getBlockBiome(tilePos).hasSurfaceSnow() && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
index 7aed0e370..184376156 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
@@ -12,11 +12,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicLeavesBase extends BlockLogic
-{
+public class BlockLogicLeavesBase extends BlockLogic {
     public static final int MASK_DECAY_DATA = 0b0000_1111;
     public static final int NUM_DECAY_BITS = 4;
     public static final int DECAY_FLAG_BIT = 3;
@@ -29,51 +29,49 @@ public class BlockLogicLeavesBase extends BlockLogic
     protected Block<?> sapling;
 
 
-	public BlockLogicLeavesBase(@NotNull Block<?> block, @NotNull Material material, @NotNull Block<?> sapling)
-    {
+    public BlockLogicLeavesBase(@NotNull Block<?> block, @NotNull Material material, @NotNull Block<?> sapling) {
         super(block, material);
         block.setTicking(true);
         this.sapling = sapling;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity)
-    {
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         float dropRate = 20;
-        if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(this.block) };
+        if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH)
+            return new ItemStack[]{new ItemStack(this.block)};
 
         int numDropped = 1;
 
         if (world.rand.nextInt(MathHelper.floor(dropRate)) != 0) return null;
 
-        return new ItemStack[] { new ItemStack(getSapling(), numDropped) };
+        return new ItemStack[]{new ItemStack(getSapling(), numDropped)};
     }
 
     protected Block<?> getSapling() {
         return this.sapling;
     }
+
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data)
-    {
-    	if(!enableDecay) {
-    		return;
-    	}
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        if (!enableDecay) {
+            return;
+        }
         int radius = 1;
         int chunkRadius = radius + 1;
-        if(world.areBlocksLoaded(tilePos.add(-chunkRadius, -chunkRadius, -chunkRadius), tilePos.add(chunkRadius, chunkRadius, chunkRadius))) {
+        if (world.areBlocksLoaded(tilePos.add(-chunkRadius, -chunkRadius, -chunkRadius, new TilePos()), tilePos.add(chunkRadius, chunkRadius, chunkRadius, new TilePos()))) {
             TilePos p = new TilePos(tilePos);
-            for(int dx = -radius; dx <= radius; dx++) {
-                for(int dy = -radius; dy <= radius; dy++) {
-                    for(int dz = -radius; dz <= radius; dz++) {
-                        p.set(tilePos.x + dx, tilePos.y + dy, tilePos.z + dz);
+            for (int dx = -radius; dx <= radius; dx++) {
+                for (int dy = -radius; dy <= radius; dy++) {
+                    for (int dz = -radius; dz <= radius; dz++) {
+                        p.set(tilePos.x() + dx, tilePos.y() + dy, tilePos.z() + dz);
                         Block<?> block = world.getBlock(p);
-                        if(block != null && block.getLogic() instanceof BlockLogicLeavesBase) {
+                        if (block != null && block.getLogic() instanceof BlockLogicLeavesBase) {
                             int meta = world.getBlockData(p);
                             if (!isPermanent(meta)) {
                                 world.setBlockData(p, setDecaying(meta, true));
@@ -86,37 +84,33 @@ public class BlockLogicLeavesBase extends BlockLogic
     }
 
     @Override
-    public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
-        if(world.isClientSide)
-        {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (world.isClientSide) {
             return;
         }
         int meta = world.getBlockData(tilePos);
-        if(isDecaying(meta) && !isPermanent(meta))
-        {
+        if (isDecaying(meta) && !isPermanent(meta)) {
             byte radius = 4;
             int offset = radius + 1;
             byte ySpan = 32;
             int xSpan = ySpan * ySpan;
             int halfLength = ySpan / 2;
-            if(this.adjacentTreeBlocks == null)
-            {
+            if (this.adjacentTreeBlocks == null) {
                 this.adjacentTreeBlocks = new int[ySpan * ySpan * ySpan];
             }
-            if(world.areBlocksLoaded(tilePos.add(-offset, -offset, -offset), tilePos.add(offset, offset, offset))) {
+            if (world.areBlocksLoaded(tilePos.add(-offset, -offset, -offset, new TilePos()), tilePos.add(offset, offset, offset, new TilePos()))) {
                 TilePos p = new TilePos(tilePos);
-                for(int xOffset = -radius; xOffset <= radius; xOffset++) {
-                    for(int yOffset = -radius; yOffset <= radius; yOffset++) {
-                        for(int zOffset = -radius; zOffset <= radius; zOffset++) {
-                            Block<?> block = world.getBlock(p.set(tilePos.x + xOffset, tilePos.y + yOffset, tilePos.z + zOffset));
+                for (int xOffset = -radius; xOffset <= radius; xOffset++) {
+                    for (int yOffset = -radius; yOffset <= radius; yOffset++) {
+                        for (int zOffset = -radius; zOffset <= radius; zOffset++) {
+                            Block<?> block = world.getBlock(p.set(tilePos.x() + xOffset, tilePos.y() + yOffset, tilePos.z() + zOffset));
 
                             int i = (xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength);
-                            if(block != null && block.getLogic() instanceof BlockLogicLog) {
+                            if (block != null && block.getLogic() instanceof BlockLogicLog) {
                                 this.adjacentTreeBlocks[i] = 0;
                                 continue;
                             }
-                            if(block != null && block.getLogic() instanceof BlockLogicLeavesBase) {
+                            if (block != null && block.getLogic() instanceof BlockLogicLeavesBase) {
                                 this.adjacentTreeBlocks[i] = -2;
                             } else {
                                 this.adjacentTreeBlocks[i] = -1;
@@ -125,35 +119,35 @@ public class BlockLogicLeavesBase extends BlockLogic
                     }
                 }
 
-                for(int j = 1; j <= 4; j++) {
-                    for(int dx = -radius; dx <= radius; dx++) {
-                        for(int dy = -radius; dy <= radius; dy++) {
-                            for(int dz = -radius; dz <= radius; dz++) {
-                                if(this.adjacentTreeBlocks[(dx + halfLength) * xSpan + (dy + halfLength) * ySpan + (dz + halfLength)] != j - 1) {
+                for (int j = 1; j <= 4; j++) {
+                    for (int dx = -radius; dx <= radius; dx++) {
+                        for (int dy = -radius; dy <= radius; dy++) {
+                            for (int dz = -radius; dz <= radius; dz++) {
+                                if (this.adjacentTreeBlocks[(dx + halfLength) * xSpan + (dy + halfLength) * ySpan + (dz + halfLength)] != j - 1) {
                                     continue;
                                 }
                                 int iWest = ((dx + halfLength) - 1) * xSpan + (dy + halfLength) * ySpan + (dz + halfLength);
-                                if(this.adjacentTreeBlocks[iWest] == -2) {
+                                if (this.adjacentTreeBlocks[iWest] == -2) {
                                     this.adjacentTreeBlocks[iWest] = j;
                                 }
                                 int iEast = (dx + halfLength + 1) * xSpan + (dy + halfLength) * ySpan + (dz + halfLength);
-                                if(this.adjacentTreeBlocks[iEast] == -2) {
+                                if (this.adjacentTreeBlocks[iEast] == -2) {
                                     this.adjacentTreeBlocks[iEast] = j;
                                 }
                                 int iDown = (dx + halfLength) * xSpan + ((dy + halfLength) - 1) * ySpan + (dz + halfLength);
-                                if(this.adjacentTreeBlocks[iDown] == -2) {
+                                if (this.adjacentTreeBlocks[iDown] == -2) {
                                     this.adjacentTreeBlocks[iDown] = j;
                                 }
                                 int iUp = (dx + halfLength) * xSpan + (dy + halfLength + 1) * ySpan + (dz + halfLength);
-                                if(this.adjacentTreeBlocks[iUp] == -2) {
+                                if (this.adjacentTreeBlocks[iUp] == -2) {
                                     this.adjacentTreeBlocks[iUp] = j;
                                 }
                                 int iNorth = (dx + halfLength) * xSpan + (dy + halfLength) * ySpan + ((dz + halfLength) - 1);
-                                if(this.adjacentTreeBlocks[iNorth] == -2) {
+                                if (this.adjacentTreeBlocks[iNorth] == -2) {
                                     this.adjacentTreeBlocks[iNorth] = j;
                                 }
                                 int iSouth = (dx + halfLength) * xSpan + (dy + halfLength) * ySpan + (dz + halfLength + 1);
-                                if(this.adjacentTreeBlocks[iSouth] == -2) {
+                                if (this.adjacentTreeBlocks[iSouth] == -2) {
                                     this.adjacentTreeBlocks[iSouth] = j;
                                 }
                             }
@@ -161,7 +155,7 @@ public class BlockLogicLeavesBase extends BlockLogic
                     }
                 }
             }
-            if(this.adjacentTreeBlocks[halfLength * xSpan + halfLength * ySpan + halfLength] >= 0) {
+            if (this.adjacentTreeBlocks[halfLength * xSpan + halfLength * ySpan + halfLength] >= 0) {
                 world.setBlockData(tilePos, setDecaying(meta, false));
             } else {
                 removeLeaves(world, tilePos);
@@ -169,45 +163,47 @@ public class BlockLogicLeavesBase extends BlockLogic
         }
     }
 
-    private void removeLeaves(@NotNull World world, @NotNull TilePos tilePos) {
+    private void removeLeaves(@NotNull World world, @NotNull TilePosc tilePos) {
         dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
         world.setBlockIdNotify(tilePos, 0);
     }
+
     public static boolean isPermanent(int meta) {
-    	return (meta & (0b1 << PERMANENT_FLAG_BIT)) != 0;
+        return (meta & (0b1 << PERMANENT_FLAG_BIT)) != 0;
     }
+
     public static int setPermanent(int meta, boolean permanent) {
-        if(permanent) {
+        if (permanent) {
             return meta | (0b1 << PERMANENT_FLAG_BIT);
-        }else {
+        } else {
             return meta & ~(0b1 << PERMANENT_FLAG_BIT);
         }
     }
 
     public static boolean isDecaying(int meta) {
-    	return (meta & (0b1 << DECAY_FLAG_BIT)) != 0;
+        return (meta & (0b1 << DECAY_FLAG_BIT)) != 0;
     }
 
     public static int setDecaying(int meta, boolean decaying) {
-    	if(decaying) {
-    		return meta | (0b1 << DECAY_FLAG_BIT);
-    	}else {
-    		return meta & ~(0b1 << DECAY_FLAG_BIT);
-    	}
+        if (decaying) {
+            return meta | (0b1 << DECAY_FLAG_BIT);
+        } else {
+            return meta & ~(0b1 << DECAY_FLAG_BIT);
+        }
     }
 
     @Override
-    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         return 0b1 << PERMANENT_FLAG_BIT;
     }
 
     @Override
-    public float getAmbientOcclusionStrength(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-    	return enableTreeShadowing ? 0.8f : 0.0f;
+    public float getAmbientOcclusionStrength(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        return enableTreeShadowing ? 0.8f : 0.0f;
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePos thisPos, @NotNull TilePos thatPos) {
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
         Block<?> bBlock = world.getBlock(thatPos);
 
         int thisMeta = world.getBlockData(thisPos) & ~MASK_DECAY_DATA;
